local events = {}
local TradeskillTimer_Timer = 0
local TradeskillTimer_Interval = .1
local TradeskillTimer_multiCastDelayCount = 0

--------------------------------------------------------------------
TradeskillTimer_Frame:SetScript("OnUpdate", function(self, elapsed)
	TradeskillTimer_Timer = TradeskillTimer_Timer + elapsed
	if TradeskillTimer_Timer > TradeskillTimer_Interval then
		TradeskillTimer_Tick()
		TradeskillTimer_Timer = 0
	end
end)

--------------------------------------------------------------------
function TradeskillTimer_Tick()
	local _, _, _, _, spellStart, spellEnd, spellIsTradeskill = UnitCastingInfo("player")
	
	if spellIsTradeskill and TradeSkillInputBox:IsVisible() then
		local remainderTime = ceil((spellEnd - (GetTime() * 1000) + ((spellEnd - spellStart) * (TradeSkillInputBox:GetNumber() - 1))) / 1000)
		
		-- Proper time format for remainder time
		local remainderString = ""
		if remainderTime >= 60 then
			remainderString = remainderString .. floor(remainderTime / 60) .. ":"
			remainderTime = remainderTime - (floor(remainderTime / 60) * 60)
		end
		if remainderTime < 10 and remainderString ~= "" then remainderString = remainderString .. "0" end
		remainderString = remainderString .. remainderTime

		TradeskillTimer_Text:SetText(remainderString)
		
		if TradeSkillInputBox:GetNumber() > 1 then TradeskillTimer_multiCastDelayCount = 3 end
	else
		if TradeskillTimer_multiCastDelayCount > 0 and TradeSkillInputBox:GetNumber() <= 1 then
			TradeskillTimer_multiCastDelayCount = TradeskillTimer_multiCastDelayCount - 1
		end
		
		if TradeskillTimer_multiCastDelayCount <= 0 then TradeskillTimer_Text:SetText("") end
	end
end